<template>
  <v-card class="mb-12 dossier-card" elevation="0" style="border: thin solid rgba(0, 0, 0, 0.12)">
    <v-card-title class="mb-6 highlight d-flex align-center">
      Dossier avion
      <v-menu offset-y v-if="currentMenu === 'plan_cabine' && legSelected">
        <template #activator="{ props }">
          <v-btn variant="outlined" :disabled="flight.legs.length < 2" class="pl-1 ml-4" data-cy="DossierChooseLegBtn"
            v-bind="props" rounded>
            <v-avatar size="26" class="mr-4 outlined font-weight-bold">
              {{ (legSelectedIndex ?? 0) + 1 }}
            </v-avatar>
            <span class="font-weight-bold">{{ legSelected.departure.oaci }} > {{ legSelected.arrival.oaci }}</span>
            <v-chip class="ml-4 text-uppercase status-chip" data-cy="FlightCaseLegStatus" label
              :class="getStatusClass(legSelected.status)">
              {{ legStatus[legSelected.status] }}
            </v-chip>
            <v-icon right>expand_more</v-icon>
          </v-btn>
        </template>
        <v-list>
          <v-list-item v-for="(leg, index) in flight.legs" @click="selectLeg(leg, index)" data-cy="DossierSelectLeg"
            :key="index">
            <v-list-item-title>
              <div class="d-flex align-center">
                <v-avatar size="30" class="mr-4 outlined">
                  {{ index + 1 }}
                </v-avatar>
                {{ leg.departure.oaci }} > {{ leg.arrival.oaci }}
                <v-chip class="ml-4 text-uppercase status-chip" label :class="getStatusClass(leg.status)">
                  {{ legStatus[leg.status] }}
                </v-chip>
              </div>
            </v-list-item-title>
          </v-list-item>
        </v-list>
      </v-menu>
      <v-spacer></v-spacer>
      <v-tabs slider-color="primary" v-model="currentMenu">
        <v-tab v-for="item in menuItems" :data-cy="item.dataCy" :value="item.key" :to="item.value">
          {{ item.title }}
        </v-tab>
      </v-tabs>
    </v-card-title>
    <v-card-text>
      <div v-if="loading" class="text-center">
        <v-progress-circular indeterminate color="primary">
        </v-progress-circular>
      </div>
      <NuxtPage v-else :flight="flight" :leg="legSelected" />
    </v-card-text>
  </v-card>
</template>

<script setup lang="ts">

import { LegStatus } from "~/dto/legstatus.enum";
import { getStatusClass } from "~/components/mixins/utilsMixin";
import { Flight } from "~/dto/flight.dto";
import { Leg } from "~/dto/leg.dto";

const props = defineProps<{ flight: Flight }>()

const loading = ref(true);
const legSelected: Ref<Leg | null> = ref(null);
const legSelectedIndex: Ref<number | null> = ref(null);
type MenuItem = {
  title: string
  key: string
  value?: {
    name: string
  }
  dataCy: string
}
const menuItems: Ref<MenuItem[]> = ref([
  {
    title: '1. Liste PAX',
    key: 'pax',
    value: { name: 'vols-id-dossier-pax' },
    dataCy: 'FlightCasePaxListBtn'
  },
  {
    title: '2. Liste chien',
    key: 'animal',
    value: { name: 'vols-id-dossier-animal' },
    dataCy: 'FlightCaseAnimalListBtn'
  }
]);
const currentMenu = ref<MenuItem['key'] | undefined>(undefined);
const legStatus = LegStatus;
const route = useRoute();
const { $toast, $api } = useNuxtApp();

definePageMeta({
  middleware: ['redirect-flight-case'],
})

watch(() => props.flight, () => {
  checkAircraft();
});

onMounted(async () => {
  await loadFlightData();
  checkAircraft();

  if (route.name === 'vols-id-dossier') {
    currentMenu.value = 'pax';
    navigateTo({ name: 'vols-id-dossier-pax', params: { id: route.params.id } });
    return;
  }

  if (route.name === 'vols-id-dossier-animal') {
    currentMenu.value = 'animal';
  }

  if ((route.name as string)?.includes('plan_cabine')) {
    currentMenu.value = 'plan_cabine';
  }
});

const loadFlightData = async () => {
  try {
    const values = await Promise.all([
      $api.animal.get(props.flight.id),
      $api.pax.get(props.flight.id)
    ]);
    props.flight.animals = values[0];
    props.flight.paxs = values[1];
  } catch (e) {
    $toast.error(`Erreur lors du chargement des informations du vol`);
  }
  loading.value = false;
}

const checkAircraft = () => {
  const aircraft = JSON.parse(JSON.stringify(props.flight.aircraft))
  if (!!aircraft && aircraft.name !== 'Free Seating') {
    menuItems.value.push(
      {
        title: '3. Plan cabine',
        key: 'plan_cabine',
        dataCy: 'FlightCaseSeatsBtn'
      }
    );
  }
}

const selectLeg = async (leg: Leg, index: number) => {
  legSelected.value = leg;
  legSelectedIndex.value = index;
  navigateTo({
    name: 'vols-id-dossier-plan_cabine-legId', params: { id: route.params.id, legId: legSelected.value.id.toString() },
    force: true,
    replace: true,
  });
}

watch(currentMenu, (v) => {
  if (currentMenu.value === 'plan_cabine') {
    if (!route.params.legId) {
      selectLeg(props.flight.legs[0], 0);
    } else {
      const legIndex = props.flight.legs.findIndex((l: Leg) => l.id === +route.params.legId);

      if (props.flight.legs[legIndex]) {
        selectLeg(props.flight.legs[legIndex], props.flight.legs.findIndex((l: Leg) => l.id === +route.params.legId));
      }
    }
  }
})

</script>

<style lang="scss">
.dossier-card {
  overflow: hidden;
}
</style>
